var tkprf = new Array();
tkprf["extensions.tamilkey.anjalshortcut"] = "Alt+F8";
tkprf["extensions.tamilkey.tamil99shortcut"] = "Alt+F9";
tkprf["extensions.tamilkey.baminishortcut"] = "Alt+F10";
tkprf["extensions.tamilkey.oldtwshortcut"] = "Alt+F11";
tkprf["extensions.tamilkey.newtwshortcut"] = "Alt+F12";
tkprf["extensions.tamilkey.englishshortcut"] = "Alt+F9";


function Tk_unloadAlert(evt)
{
	if(anjalshortcut.keyData.modified || baminishortcut.keyData.modified ||
		tamil99shortcut.keyData.modified || oldtwshortcut.keyData.modified ||
		newtwshortcut.keyData.modified || englishshortcut.keyData.modified)
		alert('Please restart '+navigator.appCodeName+' for changes to take effect.');
}

function Tk_setAccessKeys()
{
	var tkPrefs = Components.classes["@mozilla.org/preferences-service;1"].getService(
					Components.interfaces.nsIPrefService).getBranch("extensions.tamilkey.");
	Tk_setAccKey("anjal",tkPrefs);
	Tk_setAccKey("tamil99",tkPrefs);
	Tk_setAccKey("bamini",tkPrefs);
	Tk_setAccKey("oldtw",tkPrefs);
	Tk_setAccKey("newtw",tkPrefs);
	Tk_setAccKey("english",tkPrefs);
}

function Tk_setAccKey(kbrd,tkPrefs)
{
	if(tkPrefs.prefHasUserValue(kbrd+"shortcut"))
	{
		var ukey = document.getElementById(kbrd)
		var keypref = Tk_parseShortcut(tkPrefs.getCharPref(kbrd+"shortcut"));
		var keycode = keypref.keyCode;
		var key = keypref.key;
		var modifiers = [];
		if(keypref.altKey) modifiers.push("alt");
		if(keypref.ctrlKey) modifiers.push("control");
		if(keypref.metaKey) modifiers.push("meta");
		if(keypref.shiftKey) modifiers.push("shift");
		modifiers = modifiers.join(" ");
		ukey.removeAttribute('key');
		ukey.removeAttribute('keycode');
		ukey.removeAttribute('modifiers');
		if(key != '') ukey.setAttribute('key', key);
		if(keycode != '') ukey.setAttribute('keycode', keycode);
		ukey.setAttribute('modifiers', modifiers);
	}
}

function Tk_setShortcut(aNode)
{
		window.openDialog(
			'chrome://tamilkey/content/keyDetecter.xul',
			'_blank',
			'chrome,modal,resizable=no,titlebar=no,centerscreen',
			aNode.keyData,
			document.getElementById('dialogMessage').getAttribute('dialogMessage'),
			document.getElementById('dialogMessage').getAttribute('dialogButton')
		);
		if (aNode.keyData.modified) {
			aNode.value = aNode.keyData.string;
			var event = document.createEvent('UIEvents');
			event.initUIEvent('input', true, false, window, 0);
			aNode.dispatchEvent(event);
		}
}
function Tk_clearShortcut(aNode)
{
	aNode.value = tkprf["extensions.tamilkey."+aNode.id];
	aNode.keyData = Tk_parseShortcut(aNode.value);
	aNode.keyData.modified = true;

	var event = document.createEvent('UIEvents');
	event.initUIEvent('input', true, false, window, 0);
	aNode.dispatchEvent(event);
}

function Tk_parseShortcut(aShortcut)
{
	var keys = aShortcut.split('+');
	var keyCode = keys[keys.length-1].replace(/ /g, '_').toUpperCase();

	var key = keyCode;
	keyCode = (keyCode.length == 1 ) ? '' : 'VK_'+keyCode ;
	key = (keyCode != '') ? '' : key;
	return {
		key      : key,
		charCode : (key ? key.charCodeAt(0) : '' ),
		keyCode  : keyCode,
		altKey   : /alt/i.test(aShortcut),
		ctrlKey  : /ctrl|control/i.test(aShortcut),
		metaKey  : /meta/i.test(aShortcut),
		shiftKey : /shift/i.test(aShortcut),
		string   : aShortcut,
		modified : false
	};
}

var tamil99shortcut,anjalshortcut,baminishortcut,oldtwshortcut,newtwshortcut,englishshortcut;

function Tk_setHotKeyVals()
{
	tamil99shortcut = document.getElementById('tamil99shortcut');
	tamil99shortcut.keyData = Tk_parseShortcut(tamil99shortcut.value);
	anjalshortcut = document.getElementById('anjalshortcut');
	anjalshortcut.keyData = Tk_parseShortcut(anjalshortcut.value);
	baminishortcut = document.getElementById('baminishortcut');
	baminishortcut.keyData = Tk_parseShortcut(baminishortcut.value);
	oldtwshortcut = document.getElementById('oldtwshortcut');
	oldtwshortcut.keyData = Tk_parseShortcut(oldtwshortcut.value);
	newtwshortcut = document.getElementById('newtwshortcut');
	newtwshortcut.keyData = Tk_parseShortcut(newtwshortcut.value);
	englishshortcut = document.getElementById('englishshortcut');
	englishshortcut.keyData = Tk_parseShortcut(englishshortcut.value);
}
